<?php
/*
Plugin Name: Receive Links Plugin
Plugin URI: http://www.receivelinks.com/wordpress_plugin.php
Description: A plugin to include Receive Links Client on a Wordpress widget
Author: Reveive Links Support Staff 
Version: 1.1
*/

/*  
    Copyright 2010  Receive Links Support Staff  (email : support@receivelinks.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

if (!defined('RLPLUGINDIR')) {
	define('RLPLUGINDIR',dirname(__FILE__));
}

if (!function_exists('receivelinks_randomid')){
	function receivelinks_randomid(){
		return substr(md5(time()),0,14).rand(10,99);
	}
}

if (!function_exists('receivelinks_plugin_activate')){
	function receivelinks_plugin_activate(){
		/* 
		This will be ran when the plugin is activated in the admin panel.
		This should create and chmod the txt data file
		We also need to generate a random ID for the datafile
		So no one will be able to see whats in the data is unless they know the filename
		*/
		$siteurl =  get_option('siteurl');

		$id = get_option("receivelinks_id");
		if (strlen($id) != 16){
			$id = receivelinks_randomid();
			update_option("receivelinks_id", $id);
		}
		
		if (!is_file(trailingslashit(RLPLUGINDIR).'rl'.$id.'data.txt')) {
			$handle = fopen(trailingslashit(RLPLUGINDIR).'rl'.$id.'data.txt', 'x+');
			chmod(trailingslashit(RLPLUGINDIR).'rl'.$id.'data.txt', 0666);
		}
		
		// copying template client code to new file name and replaceing key items
		if (!is_file(trailingslashit(RLPLUGINDIR).'rl'.$id.'client.php')) {
			$handle = fopen(trailingslashit(RLPLUGINDIR).'rlwordpressclient.php', 'r');
			$client_data = "";
			while(!feof($handle)){
				$client_data .= fread($handle,1024);
			}
			fclose($handle);
			
			$client_data = str_replace(array('uniquereid', 'client_folder'),array($id, trailingslashit(RLPLUGINDIR)),$client_data);
			
			$handle = fopen(trailingslashit(RLPLUGINDIR).'rl'.$id.'client.php', 'x+');
			fwrite($handle,$client_data);
			fclose($handle);
			chmod(trailingslashit(RLPLUGINDIR).'rl'.$id.'client.php', 0666);
		}

		$pos = strpos(RLPLUGINDIR,PLUGINDIR);
		if ($pos){
			$folder = substr(RLPLUGINDIR,$pos);
		}

		// sending an update to the Receive Links server to update the clients random id so it will know where to look for it.
		$fp = fsockopen("www.receivelinks.com", 80, $errno, $errstr, 30);
		if ($fp){
		    $out = "GET /wordpress_plugin_comm.php?url=".$siteurl."&id=".$id."&folder=".$folder." HTTP/1.1\r\n";
		    $out .= "Host: www.receivelinks.com\r\n";
		    $out .= "Connection: Close\r\n\r\n";
		    fwrite($fp, $out);
		    fclose($fp);
		}
	}
}

if (!function_exists('receivelinks_plugin_getlinks')){
	function receivelinks_plugin_getlinks(){
		$id = get_option("receivelinks_id");
		include (trailingslashit(RLPLUGINDIR).'rl'.$id.'client.php');
		echo RECEIVE_LINKS_GetAds();
	}
}

if (!function_exists('receivelinks_widget')){
	function receivelinks_widget($args){
		extract($args);
		echo $before_widget;
		echo $before_title.'<h2>Links</h2>'.$after_title;
		receivelinks_plugin_getlinks();
		echo $after_widget;
	}
}

if (!function_exists('receivelinks_widget_init')){
	function receivelinks_widget_init(){
		if (function_exists('register_sidebar_widget')) {
			register_sidebar_widget(__('Receive Links'), 'receivelinks_widget');    
		}
	}
}

register_activation_hook(__FILE__, 'receivelinks_plugin_activate');
add_action('wp_footer', 'receivelinks_plugin_getlinks');
add_action("plugins_loaded", "receivelinks_widget_init");
?>